// ------------------------------------------------------------------------------
//  <autogenerated>
//      This code was generated by a tool.
//      Mono Runtime Version: 4.0.30319.1
// 
//      Changes to this file may cause incorrect behavior and will be lost if 
//      the code is regenerated.
//  </autogenerated>
// ------------------------------------------------------------------------------
using UnityEngine;
using System.Collections;
using System.Runtime.InteropServices;
using KTPlaySDKJson;


public class KTLeaderboardCallbackParams
{
	private const string KEY_WHAT = "what";
	private const string KEY_PARAMS = "params";
	private const string KEY_REQINFO = "requestInfo";
	
	public enum KTLeaderboardEvent
	{
		/// <summary>
		///   好友排行榜数据事件
		/// </summary>
		KTPlayLeaderboardEventFriendsLeaderboard = 300,
		/// <summary>
		///   游戏排行榜数据事件
		/// </summary>
		KTPlayLeaderboardEventGlobalLeaderboard,
		/// <summary>
		///   上传得分事件
		/// </summary>
		KTPlayLeaderboardEventReportScore,
		/// <summary>
		///   上周好友排行榜数据事件
		/// </summary>
		KTPlayLeaderboardEventLastFriendsLeaderboard,
		/// <summary>
		///  上周游戏排行榜数据事件
		/// </summary>
		KTPlayLeaderboardEventLastGlobalLeaderboard,
	};
	
	public KTLeaderboardEvent leaderboardEventResult;
	public KTError reportScoreLeaderboardError = null;
	public string leaderboardId = null;
	public double score;
	public string scoreTag;
	public KTError playError = null;
	
	public void ParseFromString(string s)
	{
		Hashtable data = (Hashtable)KTJSON.jsonDecode(s);
		if(data[KEY_WHAT] != null)
		{
			this.leaderboardEventResult = (KTLeaderboardEvent)((double)data[KEY_WHAT]);
			switch(this.leaderboardEventResult)
			{
				case KTLeaderboardEvent.KTPlayLeaderboardEventReportScore:
				{
					Hashtable param = (Hashtable)data[KEY_PARAMS];
					if (param ["error_code"] == null) {
						leaderboardId = (string)param[@"leaderboardId"];
					} else {
						reportScoreLeaderboardError = new KTError (param);
					}
					if(data[KEY_REQINFO] != null)
					{
						Hashtable requestInfo = (Hashtable)data[KEY_REQINFO];
						leaderboardId = (string)requestInfo[@"leaderboardId"];
						score = (double)requestInfo[@"score"];
						scoreTag = (string)requestInfo[@"scoreTag"];
					}
				} break;
			}
		}
	}
	
	public KTLeaderboardCallbackParams(string s)
	{
		this.ParseFromString(s);
	}
}

